> For the complete documentation index, see [llms.txt](https://yall.yassrobotics.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://yall.yassrobotics.com/api-reference/java-reference/networktables/orientation3d.md).

# Orientation3d

**Package:** `limelight.networktables`

Bundles a robot's 3D rotation with its angular velocity, in the shape MegaTag2 expects via [`LimelightSettings.withRobotOrientation`](/api-reference/java-reference/networktables/limelight-settings.md).

***

## Constructors

```java
Orientation3d(Rotation3d orientation, AngularVelocity yaw, AngularVelocity pitch, AngularVelocity roll)
Orientation3d(Rotation3d orientation, AngularVelocity3d angularVelocity)
```

***

## Fields

| Field             | Type                | Description                     |
| ----------------- | ------------------- | ------------------------------- |
| `orientation`     | `Rotation3d`        | Current robot rotation.         |
| `angularVelocity` | `AngularVelocity3d` | Current robot angular velocity. |

## Usage

```java
limelight.getSettings()
         .withRobotOrientation(new Orientation3d(
             gyro.getRotation3d(),
             new AngularVelocity3d(
                 DegreesPerSecond.of(gyro.getPitchVelocity()),
                 DegreesPerSecond.of(gyro.getRollVelocity()),
                 DegreesPerSecond.of(gyro.getYawVelocity()))))
         .save();
```

## See Also

* [AngularVelocity3d](/api-reference/java-reference/networktables/angular-velocity3d.md)
* [LimelightSettings#withRobotOrientation](/api-reference/java-reference/networktables/limelight-settings.md)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://yall.yassrobotics.com/api-reference/java-reference/networktables/orientation3d.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
